local module = {} 

gTemp = 0
gHumi = 0

local id = 0
local addr = 0x40
local HUMIDITY = 0xE5 -- 0xF3       --  
local TEMPERATURE = 0xE3 -- 0xF5    -- 

local function rxHumi()
  i2c.start(id)
  i2c.address(id, addr, i2c.RECEIVER)
  local r = i2c.read(id,3)  -- 2=3803,3=4204
  i2c.stop(id)
  -- return (bit.band((bit.lshift(string.byte(r,1),8)+string.byte(r,2)),0xfffc)*12500)/65536-600
  local T = string.byte(r,1)
  T = T * 256 + string.byte(r,2)
  --print(T)
  T = ((T * 12500) / 65536 - 600) / 10
  gHumi = math.floor(T) / 10           -- 4682
end

local function getHumi()
  --local q = tmr.now()
  i2c.start(id)
  i2c.address(id, addr, i2c.TRANSMITTER)
  i2c.write(id, HUMIDITY)
  i2c.stop(id)  --  1650
  --print(tmr.now() - q)
  -- tmr.delay(50000)
  tmr.create():alarm(50, tmr.ALARM_SINGLE, rxHumi)
end


local function rxTemp()
  i2c.start(id)
  i2c.address(id, addr, i2c.RECEIVER)
  local r = i2c.read(id,3) -- 2=3904,3=4100
  i2c.stop(id)
  -- return (bit.band((bit.lshift(string.byte(r,1),8)+string.byte(r,2)),0xfffc)*17572)/65536-4685
  local T = string.byte(r,1)
  T = T * 256 + string.byte(r,2)
  --print(T)
  T = ((T * 17572) / 65536  - 4685) / 10
  gTemp = math.floor(T) / 10
  tmr.create():alarm(10, tmr.ALARM_SINGLE, getHumi)   -- 5419
end

local function getTempX()
  i2c.start(id)
  i2c.address(id, addr, i2c.TRANSMITTER)
  i2c.write(id, TEMPERATURE)
  i2c.stop(id)  --  1650
  -- tmr.delay(50000) --wait for measurment
  tmr.create():alarm(50, tmr.ALARM_SINGLE, rxTemp)
end

function getTemp()
  tmr.create():alarm(10, tmr.ALARM_SINGLE, getTempX)
end


function module.init()    
    i2c.setup(id, 3, 4, i2c.SLOW) -- was 1,2 didn't work local HTUSDA = 3, HTUSCL = 4
    getTempX()
end

return module
