local module = {} 

local glMode = 0
local glSleep = 0	-- if zero, wake up each time
local glData = 0
local glClk = 0
local glTkWait = 0
local glTkLimit = 0

gPres = 0
--gBits={}
--gResults={}

local function clockIt()
  gpio.write(glClk, 1)
  gpio.write(glClk, 0)
end

local function waitReady()
  local bit = gpio.read(glData)
  if bit == 1 then
    glTkWait = glTkWait + 10	-- fsk was 1
	if (glTkWait > glTkLimit) then	-- wait 400 ms
	  gPres = 999999
      -- print(bit)
	  return
	end
    tmr.create():alarm(10, tmr.ALARM_SINGLE, waitReady)	-- try again
    return
  end

  local result = 0;
  -- get the first bit
  clockIt()
  result = result + result	-- delay a bit? need 100 ns
  bit = gpio.read(glData)  
  if bit == 1 then
    result = -1
  end
--  gBits[1] = bit
--  gResults[1] = result
  
  for i=2,24 do
    clockIt()
    result = result + result	--  result = result << 1
    bit = gpio.read(glData)
	result = result + bit
 --   gBits[i] = bit
 --   gResults[i] = result
  end
  gPres = result
  -- set up next sample
  for i=0, glMode do	-- 25, 26, and 27th pulses.
    clockIt()
  end

  -- go to sleep if that's what we want...
  gpio.write(glClk, glSleep)	-- 

--    for i = 1, 24 do
--      print(i..": ".. gBits[i].." "..gResults[i])
--    end
--   print("pres: "..gPres.." ticks: "..glTkWait.." sleep: "..glSleep)
  
end


function module.getPres(mode, sleep)	-- for later, reset mode for next sample
--  print("get pressure")
  gpio.write(glClk, 0)	-- wake up
  glTkWait = 0
  tmr.create():alarm(1, tmr.ALARM_SINGLE, waitReady)
end

function module.init(clk, data, mode, sleep)
  glData = data
  glClk = clk
  glMode = mode
  glSleep = sleep
  glTkLimit = 400

--  gpio.mode(glClk, gpio.OPENDRAIN)	--clock line
  gpio.mode(glClk, gpio.OUTPUT)		--clock line
  gpio.mode(glData, gpio.INPUT)		--data input
  gpio.write(clk, glSleep)	-- 
  module.getPres()
end

--    module.init(5, 6, 0, 1)
--    function Test()
--        t6.alarm(t6, 3000, tmr.ALARM_SINGLE, Test)
--        module.getPres(0, 0)
--    end
--    print("'s6()' within 5 seconds to stop testing")
--    t6 = tmr.create()
--    Test()

return module

