-- file : mqtt_svr.lua
local module = {}

vConnect = -19

local m = nil
local vMsgs = 0
local t5 = tmr.create()

local vReason = "boot"

function send_message(vMsg)
  if m and (vConnect == 0) then
    vMsgs = vMsgs + 1    
    if vReason ~= "" then	-- dev2019-09-13: send as tail to another message
	  vMsg = vMsg.."..."..vReason
	end
    m:publish(config.TOPIC..config.ID, vMsg, 0,0)
    vReason = ""
  end
end

-- Sends a simple ping to the broker

local function send_ping()
  if m and (vConnect == 0) then
    -- if vReason ~= "" then	-- dev2019-09-13: send as tail to another message
      -- send_message(vReason)
      -- vReason = ""
    -- else
	if (vMsgs == 0) then
      send_message("quiet")
    end
  end
  vMsgs = 0
end

-- Sends my id to the broker for registration
local function register_myself(cli)
    local s = config.TOPIC..config.ID.."Q"
    print("Subscribing to: "..s)
    cli:subscribe(s,0,function(conn)
        vConnect = 0    -- no error
        print("MQTT Ok")
    end)
end

local function do_mqtt_connect()
   print("Connecting to: "..config.HOST..":"..config.PORT.." User:"..config.USER.." Pwd:"..config.PWD.." ID:"..config.ID)
   local Ok = m:connect(config.HOST, config.PORT, -- 0, --  0, -- deprecated
      function(cli) 
        vConnect = -15    -- no error
        t5.stop(t5)
        register_myself(cli)
        -- And then pings each 10 seconds
        t5.alarm(t5, 10000, 1, send_ping)   -- tmr.ALARM_AUTO
      end,
      handle_mqtt_error)
    --if Ok == false then
    --    handle_mqtt_error(m, -14) 
    --end
	-- 2019ß0920Ö added again, module stuck at -16, removed 3.2. NO, MEM LEAK> connect doesn't respond fast enough 
    t5.alarm(t5, 20 * 1000, tmr.ALARM_SINGLE, do_mqtt_connect) 
end

local function handle_mqtt_error(client, reason) 
  vConnect = reason
  print("connection failed "..reason) 	--	reason code if from connect, 17 (was "offline") 'on' handler
  module.start()
end


local function mqtt_start()
    vConnect = -16
    m = mqtt.Client(config.ID, 10, config.USER, config.PWD) -- was 120
    m:lwt(config.TOPIC..config.ID, "Offline", 0, 0)
    -- register message callback beforehand
    m:on("message", function(conn, topic, data) 
      if data ~= nil then
        -- print(topic .. ": ".. data)
        MM_doCommand(topic, data)
      end
    end)
    m:on("offline", function(client)
      -- if (m == client) then
        -- print("equal")
      -- end
      if (m ~= client) then
        print("Client?")
      end
      handle_mqtt_error(client, -17)	--	was "offline")
      end)
    -- Connect to broker
    do_mqtt_connect()
end

function module.stop()
  vConnect = -18
  t5.stop(t5)  -- don't unregister
  if m then
    -- local c = m		-- no need, not multithreaded also 'm' is not 'module'
    m = nil
    print("stopping MQTT")
    -- c:close()
    -- c = nil
  end
end

function module.start()
  module.stop()
  mqtt_start()
end

return module
