-- a simple telnet server

-- restart server if needed
function telnet_close()
  if telnet_srv ~= nil then
      telnet_srv:close()
  end
  telnet_srv = nil
  node.output(nil)
end

telnet_close()
telnet_srv = net.createServer(net.TCP, 180)

telnet_srv:listen(23, function(socket)
    local fifo = {}
    local fifo_drained = true

    local function sender(c)
        if #fifo > 0 then
            c:send(table.remove(fifo, 1))
        else
            fifo_drained = true
        end
    end

    local function s_output(str)
        table.insert(fifo, str)
        if socket ~= nil and fifo_drained then
            fifo_drained = false
            sender(socket)
        end
    end

    node.output(s_output,1)   -- re-direct output to function s_ouput.

    socket:on("receive", function(c, l)
        --print(l)
        node.input(l)           -- works like pcall(loadstring(l)) but support multiple separate line
    end)
    socket:on("disconnection", function(c)
        node.output(nil)        -- un-regist the redirect output function, output goes to serial
    end)
    socket:on("sent", sender)

    print("Welcome to NodeMCU world.")
end)

print("Telnet server running...")
