----------------
-- Web Server --
----------------
--gRestart = 0

local module = {}

function Config_save()		--	was local, but we need this global for use from anywhere.
  local vName = "config.lua"
  file.remove(vName);
  file.open(vName, "w");
  local w = file.writeline
  w('-- file : config.lua');
  w('local module = {}');
  for k,v in pairs(config) do 
    local s = 'module.'..k..' = "'..v..'"'
    w(s)
  end
  w('return module');
  file.close();
end

function getWifiStatus()		-- dev2020-07-24 moved from InfMain.lua needed for www, not mqtt
  local vIP = wifi.sta.getip()
  if vIP == nil then
    vIP = "nil"
  end
  
  local _,_,d4 = vIP:find("%d*.%d*.%d*.(%d*)")
  --print(d)
  if d4 == nil then
    d4 = "nil"  
  end
  
  local vRssi = wifi.sta.getrssi()
  if vRssi == nil then
    vRssi = "nil"
  end

  return vRssi.."."..d4
end

local sMatch

function setPost(vStrAdd)
  sMatch = "HOST,PORT,ID,TOPIC,USER,PWD,ssid,pwd,"	-- PWD is for MQTT
  if vStrAdd then
    sMatch = sMatch .. vStrAdd
  end
end


local function urldecode(s)
  s = s:gsub('+', ' ')
       :gsub('%%(%x%x)', function(h)
                           return string.char(tonumber(h, 16))
                         end)
  return s
end

      -- another function
local function esp_update(PostInfo)

    print(PostInfo)
	for k, v in string.gmatch(PostInfo, "([^=&]*)=([^=&]*)&*") do
		-- print(k,v)
		local q = urldecode(v)
		if string.find(sMatch, k) then
		  local s = 'config.'..k..' = "'..q..'"'
			print(s)
		  local f, err = loadstring(s) -- node.input(s..'\n')	--	dev added \n
		  if f then
			f()
			print("ok", s)
		  else
			print("ng", err)
		  end
		else
		  if k == "cmd" then
			  if q == "Save" then
				--print("Saving...")
				Config_save()
				app.start() -- restart the client
			  elseif q == "Restart" then
				--print("Restarting...")
				node.restart()
				return 1
			  else
				module.stop()
				wui = nil
				--nh()
				return 1
			  end
		  elseif k == "net" then
		    if q == "Save" then
			  --print("Reconfigure: "..config.ssid.." "..config.pwd)
			  wifi.sta.config(config)
			else
			  --print("Restoring...")
			  node.restore()
			  node.restart()
			end
            return 1
		  else
		    print("unk",k,v)
		  end
		end
	end

    PostInfo = nil

    return 0
end 

local Q = {}
vWQ = 0
--local vNF = 'HTTP/1.0 404 Not Found\r\nConnection: close\r\n\r\n'

local function OnReceive(sck, payload)
    print(payload, vWQ)

    if vWQ ~= 0 then
      Q[sck] = payload
      return
    end
    vWQ = 30

    do
      local sta_config = wifi.sta.getconfig(true)
      config.ssid = sta_config.ssid
      config.pwd = sta_config.pwd
    end

    local vFile = "conf.htm"
    local typ = "htm"
    local size = 0
    local ct = ""

    local function SnC(sk)
      sk:close()
      vWQ = 0
    end

    local e = payload:find("\r\n",1,true)
    if e then 
      local line = payload:sub(1, e - 1)
      local _,_, meth, url = line:find("^([A-Z]+) (.-) HTTP/[1-9]+.[0-9]+$")
      print(meth, url)
      if #url > 1 then
        local vF = url:sub(2, #url)
        --print(vF, vFile)
        local s = file.stat(vF)
        if s then
          --print("name: " .. s.name..", size: " .. s.size)
          size = s.size
          vFile = vF
          local _,_,t = vF:find(".*%.(.+)$")
          --print(t)
          typ = t -- ok if nil
          ct = "image/"..t
        else
          vFile = "nf.htm"
          --print(vNF)
          --sck:send(vNF)
          --SnC(sck)
          -- return
        end
      end
    end

    local postparse = {string.find(payload,"\r\n\r\n")}
   
    --If POST value exist, run the Functions above
    if postparse[2] ~= nil then 
      local _PostInfo = string.sub(payload,postparse[2]+1,#payload)
      -- payload = nil
      if esp_update(_PostInfo) ~= 0 then
        SnC(sck)
        return
      end
    end

    local function done(sk)
        file.close()
        SnC(sk)
        for sk, pay in pairs(Q) do
          --print(sk, pay)
          if sk then
            Q[sk] = nil
            return OnReceive(sk, pay)
          end
        end
    end

    local function bsend(sk)
      local s = file.read(256)
      if s then
        sk:send(s)
        -- s=nil
      else
        done(sk)
      end
    end

    local function send(sk)
      s = file.readline()
      if s then
        s=string.sub(s,1,-2)
        if string.find(s,"%.%.") then
          s = "s='"..s.."'"
          local f, err = loadstring(s)
          if f then
            f()
            print(s)
          else
            print(err)
          end
        end
        sk:send(s..'\n')
        s=nil
      else
        done(sk)
      end
    end
    
    -- triggers the send() function again once the first chunk of data was sent
    local SF = send
    if typ ~= "htm" then
      SF = bsend
      sck:send('HTTP/1.0 200 OK\r\nContent-type: '..ct..'\r\nContent-length: '..size..'\r\n\r\n')
    end
    sck:on("sent", SF)
    file.open(vFile,"r")
    SF(sck)
end

function module.stop()
    --nh()
    if srv ~= nil then
      print("Closing Web Server...")
      srv:close()
      srv = nil
      --nh()
    end
end

function module.start()
    if not MMStatus then MMStatus = "off" end
    module.stop()
    -- Create a server object with 30 second timeout
    print("Starting Web Server...")
    srv = net.createServer(net.TCP, 30)

    srv:listen(8080, function(conn)
      conn:on("receive", OnReceive)
    end) -- srv:listen
end

return module
